### 文字クラスを確認する
# TESTCASES=[cc_alnum]  alnum文字クラスを確認する
# TESTCASES=[cc_alpha]  alpha文字クラスを確認する
# TESTCASES=[cc_ascii]  ascii文字クラスを確認する (非標準)
# TESTCASES=[cc_blank]  blank文字クラスを確認する
# TESTCASES=[cc_cntrl]  cntrl文字クラスを確認する
# TESTCASES=[cc_digit]  digit文字クラスを確認する
# TESTCASES=[cc_graph]  graph文字クラスを確認する
# TESTCASES=[cc_lower]  lower文字クラスを確認する
# TESTCASES=[cc_print]  print文字クラスを確認する
# TESTCASES=[cc_punct]  punct文字クラスを確認する
# TESTCASES=[cc_space]  space文字クラスを確認する
# TESTCASES=[cc_upper]  upper文字クラスを確認する
# TESTCASES=[cc_word]   word文字クラスを確認する (非標準)
# TESTCASES=[cc_xdigit] xdigit文字クラスを確認する

case "$TEST" in
    cc_*)
        TESTDATA=$'
     000 nul  001 soh  002 stx  003 etx  004 eot  005 enq  006 ack  007 bel
     010 bs   011 ht   012 nl   013 vt   014 np   015 cr   016 so   017 si
     020 dle  021 dc1  022 dc2  023 dc3  024 dc4  025 nak  026 syn  027 etb
     030 can  031 em   032 sub  033 esc  034 fs   035 gs   036 rs   037 us
     040 sp   041  !   042  "   043  #   044  $   045  %   046  &   047  \'
     050  (   051  )   052  *   053  +   054  ,   055  -   056  .   057  /
     060  0   061  1   062  2   063  3   064  4   065  5   066  6   067  7
     070  8   071  9   072  :   073  ;   074  <   075  =   076  >   077  ?
     100  @   101  A   102  B   103  C   104  D   105  E   106  F   107  G
     110  H   111  I   112  J   113  K   114  L   115  M   116  N   117  O
     120  P   121  Q   122  R   123  S   124  T   125  U   126  V   127  W
     130  X   131  Y   132  Z   133  [   134  \   135  ]   136  ^   137  _
     140  `   141  a   142  b   143  c   144  d   145  e   146  f   147  g
     150  h   151  i   152  j   153  k   154  l   155  m   156  n   157  o
     160  p   161  q   162  r   163  s   164  t   165  u   166  v   167  w
     170  x   171  y   172  z   173  {   174  |   175  }   176  ~   177 del'
        printf "TESTDATA=%s\n\n" "${TESTDATA}"
        printf "GREP=%s\n" "${GREP-egrep}" 
        ;;
esac

case "$TEST" in
    cc_alnum)
        echo "[:alnum:]記号クラスを確認する"
        regexp='[[:alnum:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_alpha)
        echo "[:alpha:]記号クラスを確認する"
        regexp='[[:alpha:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_ascii)
        echo "[:ascii:]記号クラスを確認する (非標準)"
        regexp='[[:ascii:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_blank)
        echo "[:blank:]記号クラスを確認する"
        regexp='[[:blank:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_cntrl)
        echo "[:cntrl:]記号クラスを確認する"
        regexp='[[:cntrl:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_digit)
        echo "[:digit:]記号クラスを確認する"
        regexp='[[:digit:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_graph)
        echo "[:graph:]記号クラスを確認する"
        regexp='[[:graph:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_lower)
        echo "[:lower:]記号クラスを確認する"
        regexp='[[:lower:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_print)
        echo "[:print:]記号クラスを確認する"
        regexp='[[:print:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_space)
        echo "[:space:]記号クラスを確認する"
        regexp='[[:space:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_upper)
        echo "[:upper:]記号クラスを確認する"
        regexp='[[:upper:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_word)
        echo "[:word:]記号クラスを確認する (非標準)"
        regexp='[[:word:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_xdigit)
        echo "[:xdigit:]記号クラスを確認する"
        regexp='[[:xdigit:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;

    cc_punct)
        echo "[:punct:]記号クラスを確認する"
        regexp='[[:punct:]]' explain="文字クラスを用いた場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        echo 
        #regexp=$'[!"#$%&\'()*+,\-./:;<=>?@\[\]^_‘{|}~]'
        #regexp=$'[!"#$%&\'()*+,./:;<=>?@^_‘{|}~[\\\\]-]'
        #regexp=$'[\\!"#$%&\'()*+,./:;<=>?@^_‘{|}~[\]-]'
        regexp=$'[\\!"#$%&\'()*+,./:;<=>?@^_{|}~[\]-]'
        explain="記号クラスをブラケット記法した場合"
        echo "regexp='$regexp'" "$explain"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"${TESTDATA}"
        exit
        ;;
esac

