##### 非正規言語 ##################
# TESTCASES=[dyck]      非正規言語 Dyck言語
# TESTCASES=[recursion] 非正規言語 再帰
# TESTCASES=[nonprime]  非正規言語 非素数言語 正規表現技術入門 p.299
# TESTCASES=[squares]   非正規言語 畳語 正規表現技術入門 p.299
# TESTCASES=[ab]        非正規言語 abだけによる畳語 後方参照 {𝑤𝑤 | 𝑤∈{𝑎,𝑏}∗}

case "$TEST" in
    dyck)  _pcre
        echo "Dyck言語: $GREP"
        regexp='\(.*((?R))*\)'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
()
a
a)
a)(
This is (an apple).
((a))
((a)(a))
TESTDATA
        exit
        ;; # ()の対応が取れているか

    recursion)  _pcre
        echo "再帰: $GREP" # https://www.regular-expressions.info/recurse.html
        regexp='a(?R)?b'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
a
ab
abb
aabb
aaab
aaabbb
TESTDATA
        exit
        ;; # 連続したaの数とbが同数か

    nonprime)  _pcre # 後方参照
        echo "非素数言語: $GREP" # 正規表現技術入門 p.299
        regexp='^a?$|^(aa+)(\1)+$'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"

a
aa
aaa
aaaa
aaaaa
aaaaaa
aaaaaaa
aaaaaaaa
aaaaaaaaa
aaaaaaaaaa
aaaaaaaaaaa
aaaaaaaaaaaa
TESTDATA
        exit
        ;; # aの数は非素数個

    squares)  # 後方参照
        echo "Squares Language 畳語: $GREP" # 正規表現技術入門 p.299
        regexp='^(.+)\1$'
        echo "regexp='$regexp'"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
yamy
jack
ab
aba
abab
papa
TokyoTokyo
TESTDATA
        exit
        ;; # aの数は非素数個

    ab)  # 後方参照 # 
        echo "abだけの畳語 matches {𝑤𝑤 | 𝑤∈{𝑎,𝑏}∗}: $GREP"
        regexp='^([ab]*)\1$'
        echo "regexp='$regexp'"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
ab
aba
abab
baba
bbabaa
baabaa
aaababbba
TESTDATA
        exit
        ;; # aとbでできた畳語
esac

