##### PCREパターン ########
# TESTCASES=[lookaround]   Lookaround - 部分マッチのポイントを確認
# TESTCASES=[lookhaeadand] 先読みでANDを実現 正規表現技術入門 p.51
# TESTCASES=[pcreK] 特殊グルーピング "\K" の動作検証 SD202106の記事 p.73 正規表現入門

case "$TEST" in
    lookaround)  _pcre
        echo "Lookaround - 部分マッチのポイントを確認: $GREP"
        regexp='(?<=e)q(?=u)' # 肯定
        #regexp='(?<=e)q(?!u)' # 否定
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} < /usr/share/dict/words
        # eの後に'q'その後にu、どこがマッチする箇所(e,uは含むのか)か確認
        # egrep --color=auto 'equ' /usr/share/dict/words と比較
        # -oオプションで抜き出すと結果は異なる
        exit
        ;;

    lookaheadand) _pcre
        echo "先読みでANDを実現: $GREP" # 正規表現技術入門 p.51
        regexp='(?=.*もも.*)(?=.*やみ.*)(?=.*くも.*).*'
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
やみくもにももをくらう
それならくもがやみにまみれるのももどかしい
くもといっしょにももをくらう
このももももやみー
このくもももももやみー
TESTDATA
        exit
        ;;

    pcreK)  _pcre
        echo "SD202106 p.75 正規表現入門: $GREP"
        echo "  対象データは、以下から取得:"
        echo "  git clone https://github.com/ryuichiueda/ShellGeiData.git"
        echo "  PCREでの「\K以前にマッチした箇所を除外する」特殊グルーピング指定子'\K'の動作を確認"
        echo
        regexp='^(\d{2,3})-(?1)-(?1)$'
        echo "\Kを指定しない: regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} ~/GitHub/ShellGeiData/sd202106/numbers
        echo
        regexp='^(\d{2,3})-(?1)-\K(?1)$'
        echo "\Kを指定する: regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} ~/GitHub/ShellGeiData/sd202106/numbers
        exit
        ;;
esac

