##### パフォーマンス調査
# TESTCASES=[perfse] state explosion 正規表現技術入門 p.100
# TESTCASES=[perfbt] back tracking 正規表現技術入門 p.233

case "${OS}" in
    Darwin*) TIME="/usr/bin/time -l" ;;
    *)       TIME="/usr/bin/time -v"  ;;
esac

case "$TEST" in
    perfse) # state explosion 正規表現技術入門 p.100
        echo "状態爆発"
        echo " DFA型(RE2, cgrep, GNU grep)で起きる状態爆発の検証"
        echo " 状態爆発が起きれば、処理に時間がかかる"
        echo
        regexp='a[^x]{20}b'

        
        for GREP in $(which egrep) $(which gegrep) $(which pcregrep) $(which pcre2grep) ; do
            [ -x $GREP ] || continue
            echo "GREP=${GREP} regexp='$regexp'"
            $GREP --version
            $TIME ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"aaaaaaaaaaaaaaaaaaaaaaaaaaaaaab"
            echo "status=$?"
            echo
        done
        exit
        ;; # 要検証 2022-1-24

    perfbt) # back tracking 正規表現技術入門 p.233
        echo "Back Trackng Problem : ${GREP-egrep}"
        echo " pcreなどVM型の問題、egrepでは問題ない"
        regexp='^(a?){30}a{30}$' explain="?では、VMで問題"
        echo "regexp='$regexp'" "$explain"
        $TIME ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
        echo "status=$?"
        echo
        regexp='^(a??){30}a{30}$' explain="??を用いることでVMでの問題の解決"
        echo "regexp='$regexp'" "$explain"
        $TIME ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<<"aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
        echo "status=$?"
        # GNU grep(DFA型) と pcregrep(VM型) で比較
        # pcre2grep: Error -46, -47, -53 or -63 means that a resource limit was exceeded.
        # pcre2grep: Check your regex for nested unlimited loops.
        exit
        ;;
esac

unset TIME

