####  Quantifiers 量化子 ####
# TESTCASES=[q]   量子化 ?  Greedy Quantifier
# TESTCASES=[qq]  量子化 ?? Layzy Quantifier
# TESTCASES=[qp]  量子化 ?+ Possessive Quantifier
# TESTCASES=[qs]  量子化 *? Lazy Quantifier
# TESTCASES=[qpq] 量子化 +? Layzy Quantifier

case "$TEST" in
    # https://www.regular-expressions.info/refrepeat.html
    # https://murashun.jp/article/programming/regular-expression.html
    q)  # ERE
        echo "?  Greedy Quantifier : ${GREP-egrep}"
        echo 'abc? matches abc or ab'
        regexp='abc?'
        echo "regexp='$regexp'"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
a
ab
abc
abcc
abcd
TESTDATA
        echo
        echo "matching result:"
        echo '  maOS  egrep    : ab, abc'
        echo '  maOS  gegrep   : ab, abc'
        echo '  maOS  pcre2grep: ab, abc'
        echo '  Linux egrep    : ab, abc'
        echo '  Linux grep -P  : ab, abc'
        exit
        ;;

    qq) _pcre
        echo "?? Layzy Quantifier: $GREP"
        echo 'abc?? matches ab or abc'
        regexp='abc??'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
a
ab
abc
abcc
abcd
TESTDATA
        echo
        echo "matching result:"
        echo "  maOS  pcre2grep: ab"
        echo "  maOS  ggrep -P : ab"
        echo "  Linux grep -P  : ab"
        echo "  [参考] Linux egrep : ab, abc ← エラーにはならないが結果が異なる"
        exit
        ;;

    qp) _pcre
        echo "?+ Possessive Quantifier: $GREP"
        echo 'abc?+c matches abcc but not abc'
        regexp='abc?+c'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
a
ab
abc
abcc
abcd
TESTDATA
        echo
        echo "matching result:"
        echo "  maOS  pcre2grep: abcc"
        echo "  maOS  ggrep -P : abcc"
        echo "  Linux grep -P  : abcc"
        echo "  [参考] Linux egrep : abc, abcc  ← エラーにはならないが結果が異なる"
        exit
        ;;

    qs) _pcre
        echo "*? Lazy Quantifier : $GREP"
        echo '".*?" matches "def" and "ghi" in abc "def" "ghi" jkl'
        echo '検証文字列: abc "def" xxx "ghi" jkl'
        regexp='".*?"'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
abc "def" xxx "ghi" jkl
TESTDATA
        echo
        echo "matching result:"
        echo '  maOS  pcre2grep: "def", "ghi"'
        echo '  maOS  ggrep -P : "def", "ghi"'
        echo '  Linux grep -P  : "def", "ghi"'
        echo '  [参考] Linux egrep : "def" xxx "ghi"'
        exit
        ;;

    qpq) _pcre
        echo "+? Layzy Quantifier : $GREP"
        echo '".+?" matches "def" and "ghi" in abc "def" "ghi" jkl'
        echo '検証文字列: abc "def" xxx "ghi" jkl'
        regexp='".+?"'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
abc "def" xxx "ghi" jkl
TESTDATA
        echo
        echo "matching result:"
        echo '  maOS  pcre2grep: "def", "ghi"'
        echo '  maOS  ggrep -P : "def", "ghi"'
        echo '  Linux grep -P  : "def", "ghi"'
        echo '  [参考] Linux egrep : "def" xxx "ghi"'
        exit
        ;; 
esac
