### from Software Design
# TESTCASES=[sdip0] IPv4アドレス 失敗例 SD202104
# TESTCASES=[sdip2] IPv4アドレス ERE SD202104
# TESTCASES=[sdip3] IPv4アドレス PCRE SD202104
# TESTCASES=[sdgit] GitHubのリポジトリからURLを抽出 SD202104

case "$TEST" in
    sdip0)
        echo "SD202104 p.xx UNIXテキスト処理の極意 IPアドレス ERE 失敗!: $GREP"
        regexp='\b[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\b'
        echo "regexp='$regexp'"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
192.168.0.1
0.0.0.0
8.8.8.8
文中にIPアドレス172.16.24.2が含まれているケース
256.256.224.128
012.123.234.111
文中にIPアドレスのようなもの256.256.224.128が含まれているケース
TESTDATA
        exit
        ;;

    sdip1)
        echo "SD202104 p.xx UNIXテキスト処理の極意 IPアドレス ERE: $GREP"
        regexp='\b((25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])\.){3}(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])\b'
        echo "regexp='$regexp'"
        ${GREP-egrep} ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
192.168.0.1
0.0.0.0
8.8.8.8
文中にIPアドレス172.16.24.2が含まれているケース
256.256.224.128
012.123.234.111
文中にIPアドレスのようなもの256.256.224.128が含まれているケース
TESTDATA
        exit
        ;;

    sdip2)  _pcre
        echo "SD202104 p.xx UNIXテキスト処理の極意 IPアドレス PCRE (未掲載): $GREP"
        regexp='\b((?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(?:(?<!\.)\b|\.)){4}'
        echo "regexp='$regexp'"
        $GREP ${COLOROPT} ${OPTIONS} ${regexp} <<"TESTDATA"
192.168.0.1
0.0.0.0
8.8.8.8
文中にIPアドレス172.16.24.2が含まれているケース
256.256.224.128
012.123.234.111
文中にIPアドレスのようなもの256.256.224.128が含まれているケース
TESTDATA
        exit
        ;;

    sdgit)  _pcre
        echo "SD202104 p.xx UNIXテキスト処理の極意 gitのconfigからURLを抽出: $GREP"
        echo "  HOMEディレクトリ直下の GitHub/ ディレクトリにあるlocal repositoriesを想定"
        regexp='(?<=url = ).*'
        echo "  1. Lookafterを用いる方法 regexp='$regexp'"
        $GREP -ho "${regexp}"  ~/GitHub/*/.git/config
        echo 
        regexp='url = \K.*'
        echo " 2. \\Kを用いる方法 regexp='$regexp'"
        $GREP -ho "${regexp}"  ~/GitHub/*/.git/config
        exit
        ;;
esac

